this.name               = "manifest_mfd";
this.author               = "Spara";
this.copyright   = "2014 Mika Spåra";
this.licence     = "CC BY-NC-SA 3.0"; 
this.description         = "Manifest info as a MFD";
this.version            = "1.0";

//public function to notify about content changes
this.notifyCargoChange = function() {
	this.$updateManifestMFD();
}

//tracks changes in cargo space
this.$prevCargoSpaceUsed = player.ship.cargoSpaceUsed;

//update the mfd message and start a framecallback on launch
this.shipWillLaunchFromStation = function() {
	this.$updateManifestMFD();
	this.$manifestMFD = addFrameCallback(this.$manifestMonitor.bind(this));
}

//remove framecallback on docking
this.shipWillDockWithStation = function() {
	removeFrameCallback(this.$manifestMFD);
	delete this.$manifestMFD;
}

//monitor volume changes in cargo hold.
this.$manifestMonitor = function() {
	var currCargoSpaceUsed = player.ship.cargoSpaceUsed;
	//cargo scooped, destroyed or jettisoned
	if (currCargoSpaceUsed !== this.$prevCargoSpaceUsed) {
		this.$updateManifestMFD();
		this.$prevCargoSpaceUsed = currCargoSpaceUsed;
	}
}

//update the mfd message
this.$updateManifestMFD = function() {
	var message = "Cargo " + player.ship.cargoSpaceUsed + " t (" + player.ship.cargoSpaceCapacity + " t):\n";
	if (manifest.list.length === 0)
		message = message + " None.";
	else {
		var pieces = new Array();
		for (var i = 0; i < manifest.list.length; i++) {
			var m = manifest.list[i];
			pieces.push(m.quantity + " " + String.fromCharCode(215) + " "+ m.displayName);
		}
		var twoColumnRows = pieces.length - 9;
		var i = 0;
		if (twoColumnRows > 0) {
			//tabs of <1, <2, <3 and <4 width with standard font
			var tabs = ["", "    ", "         ", "             ", "                  "];
			for (i = 0; i < twoColumnRows; i++) {
				var line = " " + pieces[i];
				line = line + tabs[Math.floor(7.5 - global.defaultFont.measureString(line))];
				//space width with standard font is 0.217.
				while (global.defaultFont.measureString(line) < 7.28)
					line = line + " ";
				//hair space width with standard font is 0.0125.
				while (global.defaultFont.measureString(line) < 7.5)
					line = line + String.fromCharCode(31);
				message = message + line + pieces[i+9] + "\n";
			}
		}
		var rows = 9;
		if (pieces.length < 9) rows = pieces.length;
		for (var j = i; j < rows; j++) {
				message = message + " " + pieces[j] + "\n";
		}
	}
	player.ship.setMultiFunctionText("manifest_mfd", message);
}
